package org.robert.printer.auth;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;

public class Certificate {

    public static Certificate trustedRootCert = null;


	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	private String fingerprint;
    private String commonName;
    private String organization;
    private Date validFrom;
    private Date validTo;

    private boolean valid = false;

    public static final Certificate UNKNOWN;
    public static final Certificate EXPIRED;
    public static final Certificate UNSIGNED;

    static {
    	 HashMap<String,String> map = new HashMap<String, String>();
         map.put("fingerprint", "UNKNOWN REQUEST");
         map.put("commonName", "An anonymous request");
         map.put("organization", "Unknown");
         map.put("validFrom", "0000-00-00 00:00:00");
         map.put("validTo", "0000-00-00 00:00:00");
         map.put("valid", "false");
         UNKNOWN = Certificate.loadCertificate(map);

         map.put("fingerprint", "EXPIRED REQUEST");
         map.put("commonName", "");
         map.put("organization", "");
         EXPIRED = Certificate.loadCertificate(map);

         map.put("fingerprint", "UNSIGNED REQUEST");
         UNSIGNED = Certificate.loadCertificate(map);
    }

    static {
    	trustedRootCert = new Certificate("-----BEGIN CERTIFICATE-----" +
    			"MIIDxzCCAq+gAwIBAgIEb1l91DANBgkqhkiG9w0BAQsFADCBgTELMAkGA1UEBhMC" +
    			"UFkxFDASBgNVBAgTC0FsdG8gUGFyYW5hMRgwFgYDVQQHEw9DaXVkYWQgZGVsIEVz" +
    			"dGUxFjAUBgNVBAoTDUVpcnUgU29mdHdhcmUxFjAUBgNVBAsTDUVpcnUgU29mdHdh" +
    			"cmUxEjAQBgNVBAMTCWxvY2FsaG9zdDAeFw0xODAxMjQxODQxMzRaFw0yMzAxMjMx" +
    			"ODQxMzRaMIGBMQswCQYDVQQGEwJQWTEUMBIGA1UECBMLQWx0byBQYXJhbmExGDAW" +
    			"BgNVBAcTD0NpdWRhZCBkZWwgRXN0ZTEWMBQGA1UEChMNRWlydSBTb2Z0d2FyZTEW" +
    			"MBQGA1UECxMNRWlydSBTb2Z0d2FyZTESMBAGA1UEAxMJbG9jYWxob3N0MIIBIjAN" +
    			"BgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAi0kPBMJ/ToFe5bv0t5rQEOpB5Vjd" +
    			"nobGtd3paRUcJrMipIJEWAenvE1k92PNqLGxh64A1md6U7qA4tB239nAhn0CTVFt" +
    			"xS5bvT71W0gzL1gDCMP7SE8VXw8faUJtiJZRIrLLV6w92vQTEh3b9SW+ffnwXR3K" +
    			"fKxl8vtVilQmxh0SwFaePQTtKcOszhzjBN29RaAjcDLjPgHvxE9ZNfDljf0V5Su9" +
    			"QjajiWQt7R4Pj60dUNC0GpSRvCaayAdfCa/KrHahYrIrNpznVO6EEmmFin2ggSml" +
    			"l4UCwSVI//SktLuNq3fal/x8L/M+4zUTE+mXmxDrdcAAX2oQDvZpkYT8BQIDAQAB" +
    			"o0UwQzASBgNVHRMBAf8ECDAGAQH/AgEBMA4GA1UdDwEB/wQEAwIBBjAdBgNVHQ4E" +
    			"FgQUCaysP2/nIMmSxT3zrgpZfnL9gLkwDQYJKoZIhvcNAQELBQADggEBAClckX02" +
    			"RWZxHWLpU5MdUJg1nsSEe5g3s6WqIgh67CiIuhNJ45xC+Nwl1l0UhBMF/Iz0rCId" +
    			"XyNuXohq7zP53knP2AhK7vSDEBXji+2JIK+yNtU0qK6d7aavdpgHljdCkM/TqfW1" +
    			"bpEzT7698vthPxJW/FXTiyd2jV/xUXyxFfHtsmknIAObTOgrjmrjuRxkAMyjgBzq" +
    			"NiZlwwwBmTGKcKcrEbub3wm+NS+DpRDOlzaXeezFQTxVrsz7x2HZrtt9bmHyJaQ2" +
    			"FYRVpX+dIfc0P5c=" +
    			"-----END CERTIFICATE-----");
    }

    public Certificate(String crt) {

    }

    public Certificate() {

    }

    /**
     *
     * @param data
     * @return
     */
    public static Certificate loadCertificate(HashMap<String,String> data) {
        Certificate cert = new Certificate();

        cert.fingerprint = data.get("fingerprint");
        cert.commonName = data.get("commonName");
        cert.organization = data.get("organization");

        try {
            cert.validFrom = cert.dateFormat.parse(data.get("validFrom"));
            cert.validTo = cert.dateFormat.parse(data.get("validTo"));
        }
        catch(Exception e) {
            cert.validFrom = new Date(0);
            cert.validTo = new Date(0);
        }

        cert.valid = Boolean.parseBoolean(data.get("valid"));

        return cert;
    }
}
